# modify start of alignment if single letter followed by string of Ns
from sys import path
path.append('/nfs/users/nfs_z/zn1/src/merge/replace/replace-bin') # find ssaha.py 

VERBOSE = True
DEBUG = True
MAX_START = 10  # max no of maching bases at beginning of read before run of Ns
MIN_NRUN = 10   # minimum number of Ns in run
WITH_REFCHECK = False

def processAlignmentOutput(infil, oufil, is_verbose):
    from refsubst import Alignment
    from ssaha import Ssaha
    from sys import exit
    ssaha = Ssaha()
    ali = Alignment()
    termflg = False
    lin = infil.readline()
    readctr = 0
    while 1:
        if not lin:
            break
        ssaha.parse(lin)
        if not ssaha.ok:
            lin = infil.readline()
            continue
        if is_verbose or DEBUG:
            print "\n** read: %s" % (ssaha.qnam)

        termflg = ali.parse(infil, is_verbose, WITH_REFCHECK)
        if ali.ok:
            # from start
            (nonNpos, numN) = ali.checkNrun(MAX_START, 0, VERBOSE)
            if is_verbose:
                print "RUN_START[%s] %i %i" % (numN >= MIN_NRUN, nonNpos, numN)
            #oufil.write("OLD %s\n" % ssaha)
            if numN >= MIN_NRUN:
                if ssaha.sense == 'F':
                    ssaha.qseg = (ssaha.qseg[0] + nonNpos, ssaha.qseg[1]) 
                else:
                    ssaha.qseg = (ssaha.qseg[0] - nonNpos, ssaha.qseg[1])
                ssaha.sseg = (ssaha.sseg[0] + nonNpos, ssaha.sseg[1])
                ssaha.alilen -= nonNpos

            #from end
            (nonNpos, numN) = ali.checkNrun(MAX_START, 1, VERBOSE)
            if is_verbose:
                print "RUN_END [%s] %i %i" % (numN >= MIN_NRUN, nonNpos, numN)
            #oufil.write("OLD %s\n" % ssaha)
            if numN >= MIN_NRUN:
                if ssaha.sense == 'F':
                    ssaha.qseg = (ssaha.qseg[0], ssaha.qseg[1] - nonNpos) 
                else:
                    ssaha.qseg = (ssaha.qseg[0], ssaha.qseg[1] + nonNpos)
                ssaha.sseg = (ssaha.sseg[0], ssaha.sseg[1] - nonNpos)
                ssaha.alilen -= nonNpos

        else:
            print "ALI FALSE: %s" % (ali.lin)
       
        oufil.write("%s\n" % ssaha)
        readctr += 1
        termflg = False        
        lin = ali.lin
        if is_verbose:
            print "NEWLINE (%s): %s" % (termflg, lin)

    return readctr

if __name__ == '__main__':
    from sys import argv, exit
    from SAM import openFile
    
    if len(argv) != 3:
        exit("usage: %s <smalt_output (-f ssaha -a)> <oufilnam>" % argv[0])

    infilnam = argv[1]
    oufilnam = argv[2]
    #winhalfsiz = int(argv[2])
    #if winhalfsiz < 1: winhalfsiz = WINDOW_HALFSIZ
    infil = openFile(infilnam, 'r')
    oufil = openFile(oufilnam, 'w')
    nreads = processAlignmentOutput(infil, oufil, VERBOSE)
    print "Number of reads processed: %i" % (nreads)
    print "Output file: %s" % (oufilnam)
    oufil.close()
    infil.close()

    exit()
